~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

TOMOYO Linux Cross Reference
Linux/scripts/decodecode

Version: ~ [ linux-6.12-rc7 ] ~ [ linux-6.11.7 ] ~ [ linux-6.10.14 ] ~ [ linux-6.9.12 ] ~ [ linux-6.8.12 ] ~ [ linux-6.7.12 ] ~ [ linux-6.6.60 ] ~ [ linux-6.5.13 ] ~ [ linux-6.4.16 ] ~ [ linux-6.3.13 ] ~ [ linux-6.2.16 ] ~ [ linux-6.1.116 ] ~ [ linux-6.0.19 ] ~ [ linux-5.19.17 ] ~ [ linux-5.18.19 ] ~ [ linux-5.17.15 ] ~ [ linux-5.16.20 ] ~ [ linux-5.15.171 ] ~ [ linux-5.14.21 ] ~ [ linux-5.13.19 ] ~ [ linux-5.12.19 ] ~ [ linux-5.11.22 ] ~ [ linux-5.10.229 ] ~ [ linux-5.9.16 ] ~ [ linux-5.8.18 ] ~ [ linux-5.7.19 ] ~ [ linux-5.6.19 ] ~ [ linux-5.5.19 ] ~ [ linux-5.4.285 ] ~ [ linux-5.3.18 ] ~ [ linux-5.2.21 ] ~ [ linux-5.1.21 ] ~ [ linux-5.0.21 ] ~ [ linux-4.20.17 ] ~ [ linux-4.19.323 ] ~ [ linux-4.18.20 ] ~ [ linux-4.17.19 ] ~ [ linux-4.16.18 ] ~ [ linux-4.15.18 ] ~ [ linux-4.14.336 ] ~ [ linux-4.13.16 ] ~ [ linux-4.12.14 ] ~ [ linux-4.11.12 ] ~ [ linux-4.10.17 ] ~ [ linux-4.9.337 ] ~ [ linux-4.4.302 ] ~ [ linux-3.10.108 ] ~ [ linux-2.6.32.71 ] ~ [ linux-2.6.0 ] ~ [ linux-2.4.37.11 ] ~ [ unix-v6-master ] ~ [ ccs-tools-1.8.12 ] ~ [ policy-sample ] ~
Architecture: ~ [ i386 ] ~ [ alpha ] ~ [ m68k ] ~ [ mips ] ~ [ ppc ] ~ [ sparc ] ~ [ sparc64 ] ~

Diff markup

Differences between /scripts/decodecode (Version linux-6.12-rc7) and /scripts/decodecode (Version policy-sample)


  1 #!/bin/bash                                       
  2 # SPDX-License-Identifier: GPL-2.0                
  3 # Disassemble the Code: line in Linux oopses      
  4 # usage: decodecode < oops.file                   
  5 #                                                 
  6 # options: set env. variable AFLAGS=options to    
  7 # e.g., to decode an i386 oops on an x86_64 sy    
  8 # AFLAGS=--32 decodecode < 386.oops               
  9 # PC=hex - the PC (program counter) the oops p    
 10                                                   
 11 faultlinenum=1                                    
 12                                                   
 13 cleanup() {                                       
 14         rm -f $T $T.s $T.o $T.oo $T.aa $T.dis     
 15         exit 1                                    
 16 }                                                 
 17                                                   
 18 die() {                                           
 19         echo "$@"                                 
 20         exit 1                                    
 21 }                                                 
 22                                                   
 23 trap cleanup EXIT                                 
 24                                                   
 25 T=`mktemp` || die "cannot create temp file"       
 26 code=                                             
 27 cont=                                             
 28                                                   
 29 while read i ; do                                 
 30                                                   
 31 case "$i" in                                      
 32 *Code:*)                                          
 33         code=$i                                   
 34         cont=yes                                  
 35         ;;                                        
 36 *)                                                
 37         [ -n "$cont" ] && {                       
 38                 xdump="$(echo $i | grep '^[[:x    
 39                 if [ -n "$xdump" ]; then          
 40                         code="$code $xdump"       
 41                 else                              
 42                         cont=                     
 43                 fi                                
 44         }                                         
 45         ;;                                        
 46 esac                                              
 47                                                   
 48 done                                              
 49                                                   
 50 if [ -z "$code" ]; then                           
 51         rm $T                                     
 52         exit                                      
 53 fi                                                
 54                                                   
 55 echo $code                                        
 56 code=`echo $code | sed -e 's/.*Code: //'`         
 57                                                   
 58 width=`expr index "$code" ' '`                    
 59 width=$((($width-1)/2))                           
 60 case $width in                                    
 61 1) type=byte ;;                                   
 62 2) type=2byte ;;                                  
 63 4) type=4byte ;;                                  
 64 esac                                              
 65                                                   
 66 if [ -z "$ARCH" ]; then                           
 67     case `uname -m` in                            
 68         aarch64*) ARCH=arm64 ;;                   
 69         arm*) ARCH=arm ;;                         
 70         loongarch*) ARCH=loongarch ;;             
 71     esac                                          
 72 fi                                                
 73                                                   
 74 # Params: (tmp_file, pc_sub)                      
 75 disas() {                                         
 76         t=$1                                      
 77         pc_sub=$2                                 
 78                                                   
 79         ${CROSS_COMPILE}as $AFLAGS -o $t.o $t.    
 80                                                   
 81         if [ "$ARCH" = "arm" ]; then              
 82                 if [ $width -eq 2 ]; then         
 83                         OBJDUMPFLAGS="-M force    
 84                 fi                                
 85                                                   
 86                 ${CROSS_COMPILE}strip $t.o        
 87         fi                                        
 88                                                   
 89         if [ "$ARCH" = "arm64" ]; then            
 90                 if [ $width -eq 4 ]; then         
 91                         type=inst                 
 92                 fi                                
 93                                                   
 94                 ${CROSS_COMPILE}strip $t.o        
 95         fi                                        
 96                                                   
 97         if [ "$ARCH" = "riscv" ]; then            
 98                 OBJDUMPFLAGS="-M no-aliases --    
 99                 ${CROSS_COMPILE}strip $t.o        
100         fi                                        
101                                                   
102         if [ "$ARCH" = "loongarch" ]; then        
103                 ${CROSS_COMPILE}strip $t.o        
104         fi                                        
105                                                   
106         if [ $pc_sub -ne 0 ]; then                
107                 if [ $PC ]; then                  
108                         adj_vma=$(( $PC - $pc_    
109                         OBJDUMPFLAGS="$OBJDUMP    
110                 fi                                
111         fi                                        
112                                                   
113         ${CROSS_COMPILE}objdump $OBJDUMPFLAGS     
114                 grep -v "/tmp\|Disassembly\|\.    
115 }                                                 
116                                                   
117 # Match the maximum number of opcode bytes fro    
118 # @opline                                         
119 #                                                 
120 # Params:                                         
121 # @op_bytes: The string of bytes from the Code    
122 # @opline: The disassembled line coming from o    
123 #                                                 
124 # Returns:                                        
125 # The max number of opcode bytes from the begi    
126 # the opcode bytes in the objdump line.           
127 get_substr_opcode_bytes_num()                     
128 {                                                 
129         local op_bytes=$1                         
130         local opline=$2                           
131                                                   
132         local retval=0                            
133         substr=""                                 
134                                                   
135         for opc in $op_bytes;                     
136         do                                        
137                 substr+="$opc"                    
138                                                   
139                 opcode="$substr"                  
140                 if [ "$ARCH" = "riscv" ]; then    
141                         opcode=$(echo $opcode     
142                 fi                                
143                                                   
144                 # return if opcode bytes do no    
145                 if ! echo $opline | grep -q "$    
146                 then                              
147                         break                     
148                 fi                                
149                                                   
150                 # add trailing space              
151                 substr+=" "                       
152                 retval=$((retval+1))              
153         done                                      
154                                                   
155         return $retval                            
156 }                                                 
157                                                   
158 # Return the line number in objdump output to     
159 # line points to                                  
160 #                                                 
161 # Params:                                         
162 # @all_code: code in bytes without the marker     
163 # @dis_file: disassembled file                    
164 # @ip_byte: The byte to which the IP points to    
165 get_faultlinenum()                                
166 {                                                 
167         local all_code="$1"                       
168         local dis_file="$2"                       
169                                                   
170         # num bytes including IP byte             
171         local num_bytes_ip=$(( $3 + 1 * $width    
172                                                   
173         # Add the two header lines (we're coun    
174         local retval=3                            
175                                                   
176         # remove marker                           
177         all_code=$(echo $all_code | sed -e 's/    
178                                                   
179         while read line                           
180         do                                        
181                 get_substr_opcode_bytes_num "$    
182                 ate_opcodes=$?                    
183                                                   
184                 if ! (( $ate_opcodes )); then     
185                         continue                  
186                 fi                                
187                                                   
188                 num_bytes_ip=$((num_bytes_ip -    
189                 if (( $num_bytes_ip <= 0 )); t    
190                         break                     
191                 fi                                
192                                                   
193                 # Delete matched opcode bytes     
194                 # how many chars those opcodes    
195                 # trailing space.                 
196                 #                                 
197                 # a byte is 2 chars, ate_opcod    
198                 # spaces                          
199                 del_chars=$(( ($ate_opcodes *     
200                                                   
201                 all_code=$(echo $all_code | se    
202                                                   
203                 let "retval+=1"                   
204                                                   
205         done < $dis_file                          
206                                                   
207         return $retval                            
208 }                                                 
209                                                   
210 marker=`expr index "$code" "\<"`                  
211 if [ $marker -eq 0 ]; then                        
212         marker=`expr index "$code" "\("`          
213 fi                                                
214                                                   
215 touch $T.oo                                       
216 if [ $marker -ne 0 ]; then                        
217         # How many bytes to subtract from the     
218         # in order to get to the beginning vir    
219         # Code:                                   
220         pc_sub=$(( (($marker - 1) / (2 * $widt    
221         echo All code >> $T.oo                    
222         echo ======== >> $T.oo                    
223         beforemark=`echo "$code"`                 
224         echo -n "       .$type 0x" > $T.s         
225                                                   
226         echo $beforemark | sed -e 's/ /,0x/g;     
227                                                   
228         disas $T $pc_sub                          
229                                                   
230         cat $T.dis >> $T.oo                       
231                                                   
232         get_faultlinenum "$code" "$T.dis" $pc_    
233         faultlinenum=$?                           
234                                                   
235         # and fix code at-and-after marker        
236         code=`echo "$code" | cut -c$((${marker    
237                                                   
238         rm -f $T.o $T.s $T.dis                    
239 fi                                                
240                                                   
241 echo Code starting with the faulting instructi    
242 echo =========================================    
243 code=`echo $code | sed -e 's/\r//;s/ [<(]/ /;s    
244 echo -n "       .$type 0x" > $T.s                 
245 echo $code >> $T.s                                
246 disas $T 0                                        
247 cat $T.dis >> $T.aa                               
248                                                   
249 cat $T.oo | sed -e "${faultlinenum}s/^\([^:]*:    
250 echo                                              
251 cat $T.aa                                         
252 cleanup                                           
                                                      

~ [ source navigation ] ~ [ diff markup ] ~ [ identifier search ] ~

kernel.org | git.kernel.org | LWN.net | Project Home | SVN repository | Mail admin

Linux® is a registered trademark of Linus Torvalds in the United States and other countries.
TOMOYO® is a registered trademark of NTT DATA CORPORATION.

sflogo.php